var AMWAY = AMWAY || {};
AMWAY.IncomeSimulator = AMWAY.IncomeSimulator || {};

AMWAY.IncomeSimulator.Main = (function(){
	
	var DEFAULT_LANGUAGE_CODE = "en-us";
    var DEFAULT_COUNTRY_CODE = "us";
	var DEFAULT_PAGE_INDEX = 0;
	var _firstRun = true;
	var _currentPage;
	var _currentPageIndex;
	
	var _settings = {
		availableCountries: [
			DEFAULT_COUNTRY_CODE
		],
		languageCode: DEFAULT_LANGUAGE_CODE,
        countryCode: DEFAULT_COUNTRY_CODE,
		startingIndex: DEFAULT_PAGE_INDEX,
		local: false
	};
	
	var _loadCountry = function(countryCode)
	{
		_settings.countryCode = countryCode;
		
		AMWAY.IncomeSimulator.Profiles.onLoadStart();
		
		AMWAY.IncomeSimulator.Loader.addToQueue('settings/countries/country-'+countryCode+'.txt', 'AMWAY.IncomeSimulator.Country.onLoad');
		AMWAY.IncomeSimulator.Loader.addToQueue('settings/profiles/profiles-'+countryCode+'.txt', 'AMWAY.IncomeSimulator.Profiles.onLoad');
		AMWAY.IncomeSimulator.Loader.addToQueue('settings/simulator/simulator-'+countryCode+'.txt', 'AMWAY.IncomeSimulator.Simulator.onLoad');
		AMWAY.IncomeSimulator.Loader.processQueue('AMWAY.IncomeSimulator.Main.onCountryLoad');
	};
	
	var _loadLanguage = function(languageCode)
	{
		_settings.languageCode = languageCode;
		AMWAY.IncomeSimulator.Loader.addToQueue('settings/translations/translation-'+languageCode+'.txt', 'AMWAY.IncomeSimulator.Translation.onLoad');
		AMWAY.IncomeSimulator.Loader.processQueue('AMWAY.IncomeSimulator.Main.onLanguageLoad');
	};
	
	var _onCountryLoad = function()
	{
		_loadLanguage(_settings.languageCode);
	};
	
	var _onLanguageLoad = function()
	{
		if(_firstRun)
		{
			_firstRun = false;
			_initUI();
			
			SWFAddress.onChange = function()
			{
				var pathNames = SWFAddress.getPathNames();
				
				switch(pathNames[0])
				{
					case 'home':
						_showPageIndex(0);
						break;
					case 'profiles':
						_showPageIndex(1);
						break;
					case 'simulator':
						
						switch(pathNames[1])
						{
							case 'my-goals':
								AMWAY.IncomeSimulator.Simulator.showTabIndex(0);
								break;
							case 'retailing':
								AMWAY.IncomeSimulator.Simulator.showTabIndex(1);
								break;
							case 'business-building':
								AMWAY.IncomeSimulator.Simulator.showTabIndex(2);
								break;
							default:
								SWFAddress.setValue('simulator/my-goals');
								return;
						}
						_showPageIndex(2);
						
						break;
					default:
						SWFAddress.setValue('home');
						break;
				}
			};
			
			SWFAddress.onChange();
		}
	};
	
	var _showPageIndex = function(index, callback)
	{
		if(index != _currentPageIndex)
		{
			if(_currentPage != null)
			{
			
				$(_currentPage).fadeOut(300, function(){
					_currentPage = null;
					_showPageIndex(index, callback);
				});
				return;
			}
		
			if(callback instanceof Function)
			{
				callback();
			}
		
			var el = $('.page').get(index);
			_currentPage = el;
			$(_currentPage).fadeIn(300);
		}
		
		_currentPageIndex = index;
	};

	var _initUI = function()
	{
		AMWAY.IncomeSimulator.Country.initUI();
		AMWAY.IncomeSimulator.Profiles.initUI();
		AMWAY.IncomeSimulator.Simulator.initUI();
		AMWAY.IncomeSimulator.Translation.initUI();
		// general
		$('.page#country-language-select .next-button').click(function(e){
			AMWAY.IncomeSimulator.Profiles.reset();
			SWFAddress.setValue('profiles');
			//_showPageIndex(1);
		});
		
		$('.page#owner-profiles .back-button').click(function(e){
			SWFAddress.setValue('home');
			//_showPageIndex(0);
		});
		
		
		$('.page#owner-profiles .disclaimer-button').fancybox({
			'modal' : true
		});
		
		$('.page#owner-profiles .next-button').click(function(e){
			e.preventDefault();
			$.fancybox.close();
			SWFAddress.setValue('simulator/my-goals');
		});

        $('#simulator-content-1 .next-stage-button').click(function(e){
            e.preventDefault();
            $.fancybox.close();
            SWFAddress.setValue('/simulator/retailing');
        });

        $('#simulator-content-2 .next-stage-button').click(function(e){
			e.preventDefault();
			$.fancybox.close();
			SWFAddress.setValue('/simulator/business-building');
		});

		$('#disclaimer .close-button').click(function(e){
			e.preventDefault();
			$.fancybox.close();
		});
	};
	
	var _init = function(settings)
	{
		for(var i in settings)
		{
			_settings[i] = settings[i];
		}
		
		_settings.local = false;
		
		_loadCountry(_settings.countryCode);
	};
	
	return {
		init: _init,
		onCountryLoad: _onCountryLoad,
		onLanguageLoad: _onLanguageLoad,
		settings: _settings,
		loadCountry: _loadCountry,
		loadLanguage: _loadLanguage,
		showPageIndex: _showPageIndex
	};
}());
