var AMWAY = AMWAY || {};
AMWAY.IncomeSimulator = AMWAY.IncomeSimulator || {};

AMWAY.IncomeSimulator.Translation = (function(){
	// supported languages
	var _languages = {
		'zh-cn':'Chinese',
		'zh-hk':'Chinese (Hong Kong)',
		'hr':'Croatian',
		'cs':'Czech',
		'da':'Danish',
		'nl-be':'Dutch', // Belgium
		'en-au':'English', // Australia
		'en-ca':'English', // Canada
		'en-us':'English', // United States
		'fi':'Finnish',
		'fr':'French',
		'fr-ca':'French', // Canada
		'de':'German',
		'el':'Greek',
		'hu':'Hungarian',
		'id':'Indonesian',
		'it':'Italian',
		'ja':'Japanese',
		'ko':'Korean',
		'no':'Norwegian',
		'pl':'Polish',
		'pt':'Portuguese',
		'pt-br':'Portuguese (Brazil)',
		'ro':'Romanian',
		'ru':'Russian',
		'sk':'Slovak',
		'sl':'Slovenian',
		'es':'Spanish',
		'es-co':'Spanish (Colombia)',
		'es-do':'Spanish (Dominican Republic)',
		'es-mx':'Spanish (Mexico)',
		'sv':'Swedish',
		'th':'Thai',
		'tr':'Turkish',
		'uk':'Ukrainian',
		'vi':'Vietnamese'
	};
	
	// loaded translation
	var _translation = {};
	
	/**
	 * Translate text based on class name.
	 * The first element is the translation
	 * file is used as the page title.
	 * 
	 * @param {Object} translation
	 */
	var _translate = function(translation)
	{
		for(var i in translation)
		{
			// check if element is title element.
			// JQuery's text() function can't be used to set title
			if(i == "001")
			{
				document.title = translation[i];
			}
			
			$('._'+i).text(translation[i]);
		}
	};
	
	/**
	 * Specifies language and translates text
	 * @param {Object} code
	 */
	var _setLanguage = function(languageCode)
	{
		_translate(_translations[languageCode]);
		AMWAY.Profile.setProfiles(AMWAY.IncomeSimulator.settings.countryCode, languageCode);
	};
	
	var _loadTranslation = function(languageCode)
	{
		AMWAY.JSONLoader.addToQueue('settings/translations/translation-'+languageCode+'.txt', 'AMWAY.Language.onLoad');
		AMWAY.JSONLoader.processQueue();
	};
	
	var _initUI = function()
	{
		
	};
	
	var _onLoad = function(data)
	{
		_translation = data;
		
		if(AMWAY.IncomeSimulator.Main.settings.local)
		{
			_translation = $.parseJSON(_translation);
		}

		_translate(_translation);
	};
	
	
	/**
	 * Returns language name based on language code
	 * @param {Object} code
	 */
	var _getLanguageName = function(code)
	{
		return _languages[code];
	};
	
	/**
	 * Public methods and properties
	 */
	return {
		translation: _translation,
		setLanguage: _setLanguage,
		getLanguageName: _getLanguageName,
		onLoad: _onLoad,
		initUI: _initUI
	};
}());
